Object.defineProperty(exports, "__esModule", { value: true });
exports.MiddlewareRunner = void 0;
var MiddlewareRunner = /** @class */ (function () {
    function MiddlewareRunner() {
        this._middlewares = [];
    }
    MiddlewareRunner.prototype.add = function (middleware) {
        this._middlewares.push(middleware);
    };
    MiddlewareRunner.prototype.run = function (payload, next) {
        var _this = this;
        var curMiddlewareIndex = 0;
        var middlewareCount = this._middlewares.length;
        var middlewareNext = function (curPayload) {
            curMiddlewareIndex += 1;
            if (curMiddlewareIndex < middlewareCount) {
                _this._middlewares[curMiddlewareIndex](curPayload, _next);
            }
            else {
                next(curPayload);
            }
        };
        var _next = (middlewareCount > 0) ? middlewareNext : next;
        _next(payload);
    };
    return MiddlewareRunner;
}());
exports.MiddlewareRunner = MiddlewareRunner;
//# sourceMappingURL=index.js.map